--- lib/unicase/u16-is-invariant.c	Fri Jun  8 18:19:49 2018
+++ lib/unicase/u16-is-invariant.c	Fri Jun  8 18:27:12 2018
@@ -27,10 +27,9 @@
 #include <config.h>
 
 /* Specification.  */
-#include "unicase/invariant.h"
+#include "unicase.h"
 
 #include <errno.h>
-#include <stdbool.h>
 #include <stdlib.h>
 
 #include "uninorm.h"
--- lib/unicase/u32-is-invariant.c	Fri Jun  8 18:33:33 2018
+++ lib/unicase/u32-is-invariant.c	Fri Jun  8 18:34:01 2018
@@ -27,10 +27,9 @@
 #include <config.h>
 
 /* Specification.  */
-#include "unicase/invariant.h"
+#include "unicase.h"
 
 #include <errno.h>
-#include <stdbool.h>
 #include <stdlib.h>
 
 #include "uninorm.h"
--- lib/unicase/u8-is-invariant.c	Fri Jun  8 18:41:24 2018
+++ lib/unicase/u8-is-invariant.c	Fri Jun  8 18:41:46 2018
@@ -27,10 +27,9 @@
 #include <config.h>
 
 /* Specification.  */
-#include "unicase/invariant.h"
+#include "unicase.h"
 
 #include <errno.h>
-#include <stdbool.h>
 #include <stdlib.h>
 
 #include "uninorm.h"
--- lib/unistr/u8-strchr.c	Fri May 25 18:02:15 2018
+++ lib/unistr/u8-strchr.c	Sun Jun 10 20:35:16 2018
@@ -32,6 +32,18 @@
 
 #include <string.h>
 
+int check_zero_in_str (const uint8_t *s, int n)
+{
+  for (int i = 0; i < n; i++)
+  {
+    if (s[i] == 0)
+    {
+      return 1;
+    }
+  }
+  return 0;
+}
+
 uint8_t *
 u8_strchr (const uint8_t *s, ucs4_t uc)
 {
@@ -71,7 +83,7 @@
     switch (u8_uctomb_aux (c, uc, 6))
       {
       case 2:
-        if (*s == 0 || s[1] == 0)
+        if (check_zero_in_str(s, 2))
           break;
         {
           uint8_t c0 = c[0];
@@ -114,7 +126,7 @@
         break;
 
       case 3:
-        if (*s == 0 || s[1] == 0 || s[2] == 0)
+        if (check_zero_in_str(s, 3))
           break;
         {
           uint8_t c0 = c[0];
@@ -172,7 +184,7 @@
         break;
 
       case 4:
-        if (*s == 0 || s[1] == 0 || s[2] == 0 || s[3] == 0)
+        if (check_zero_in_str(s, 4))
           break;
         {
           uint8_t c0 = c[0];
